local frame = CreateFrame("FRAME")
LibStub("AceTimer-3.0"):Embed(frame)
local state = true

frame:RegisterEvent("CHAT_MSG_SYSTEM")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")

frame:SetScript("OnEvent", function(self, event, ...)
	return self[event](self, event, ...)
end)

function frame:CHAT_MSG_SYSTEM(event, msg)
	if state and msg == TRANSFER_ABORT_TOO_MANY_REALM_INSTANCES then
		self:ScheduleTimer("RetryTeleport", AUTODUNGEONRETRY_DELAY)
		print('|cff33ff99AutoDungeonRetry:|r', "Retrying instance teleport in 5 seconds.")
	end
end

function frame:PLAYER_ENTERING_WORLD()
	AUTODUNGEONRETRY_DELAY = AUTODUNGEONRETRY_DELAY or 5
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
end

function frame:RetryTeleport()
	return LFGTeleport()
end

--slashy slashy
_G["SlashCmdList"]["AUTODUNGEONRETRY_MAIN"] = function(s)
	local num = tonumber(s)
	if num then
		AUTODUNGEONRETRY_DELAY = num
		print('|cff33ff99AutoDungeonRetry:|r', "Setting delay to:", num)
	elseif string.lower(s) == "disable" then
		state = false
		print('|cff33ff99AutoDungeonRetry:|r', "Disabled")
	elseif string.lower(s) == "enable" then
		state = true
		print('|cff33ff99AutoDungeonRetry:|r', "Enabled")
	end
end
_G["SLASH_AUTODUNGEONRETRY_MAIN1"] = "/adr"
_G["SLASH_AUTODUNGEONRETRY_MAIN2"] = "/autoretry"
